package org.jbpm.graph.part;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import org.jbpm.graph.figure.NodeFigure;
import org.jbpm.graph.model.Node;

public class NodeEditPart extends AbstractGraphicalEditPart {
	
	public NodeEditPart(Node node) {
		setModel(node);
	}

	protected IFigure createFigure() {
		return new NodeFigure();
	}

	protected void createEditPolicies() {
	}

	// Is needed to set the figure in the right location and display a
	// name.
	public void refreshVisuals() {
		NodeFigure figure = (NodeFigure)getFigure();
		Node node = (Node)getModel();
		GraphEditPart parent = (GraphEditPart)getParent();
		figure.getLabel().setText(node.getName());
		Rectangle r = new Rectangle(node.getConstraint());
		parent.setLayoutConstraint(this, figure, r);
	}
	
}
