package org.jbpm.graph;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.gef.DefaultEditDomain;
import org.eclipse.gef.EditDomain;
import org.eclipse.gef.editparts.ScalableFreeformRootEditPart;
import org.eclipse.gef.ui.parts.ScrollingGraphicalViewer;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.EditorPart;
import org.jbpm.graph.part.GraphicalEditPartFactory;

public class GraphEditor extends EditorPart {
	
	// We use an instance variable for the EditDomain, because we will need it
	// later on.
	private EditDomain editDomain; 					
	
	public GraphEditor() {
	}

	public void doSave(IProgressMonitor monitor) {
	}

	public void doSaveAs() {
	}

	public void init(IEditorSite site, IEditorInput input)
			throws PartInitException {
		setSite(site);
		setInput(input);
		// We add a init method to initialize the EditDomain.
		init();
	}

	private void init() {
		editDomain = new DefaultEditDomain(this);
	}
	
	public boolean isDirty() {
		return false;
	}

	public boolean isSaveAsAllowed() {
		return false;
	}

	public void createPartControl(Composite parent) {
		ScrollingGraphicalViewer viewer = new ScrollingGraphicalViewer();
		viewer.setRootEditPart(new ScalableFreeformRootEditPart());
		viewer.createControl(parent);
		viewer.getControl().setBackground(ColorConstants.white);
		viewer.setEditPartFactory(new GraphicalEditPartFactory());
		viewer.setContents(ContentProvider.INSTANCE.newSampleGraph());
		// Associate the viewer with the editdomain so that nodes can be selected.
		editDomain.addViewer(viewer);
	}

	public void setFocus() {
	}

}
