package org.jbpm.graph;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.draw2d.ColorConstants;
import org.eclipse.gef.DefaultEditDomain;
import org.eclipse.gef.EditDomain;
import org.eclipse.gef.editparts.ScalableFreeformRootEditPart;
import org.eclipse.gef.ui.parts.ScrollingGraphicalViewer;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.EditorPart;
import org.jbpm.graph.part.GraphicalEditPartFactory;

public class GraphEditor extends EditorPart {
	
	private EditDomain editDomain;
	
	public void doSave(IProgressMonitor monitor) {
	}

	public void doSaveAs() {
	}

	public void init(IEditorSite site, IEditorInput input)
			throws PartInitException {
		setSite(site);
		setInput(input);
		init();
	}

	private void init() {
		editDomain = new DefaultEditDomain(this);
	}

	public boolean isDirty() {
		return false;
	}

	public boolean isSaveAsAllowed() {
		return false;
	}

	public void createPartControl(Composite parent) {
		ScrollingGraphicalViewer viewer = new ScrollingGraphicalViewer();
		viewer.setRootEditPart(new ScalableFreeformRootEditPart());
		viewer.createControl(parent);
		viewer.getControl().setBackground(ColorConstants.white);
		viewer.setEditPartFactory(new GraphicalEditPartFactory());
		viewer.setContents(ContentProvider.INSTANCE.newSampleGraph());
		editDomain.addViewer(viewer);
	}

	public void setFocus() {
	}
	
//	public EditDomain getEditDomain() {
//		return editDomain;
//	}

//	public Object getAdapter(Class adapter) {
//		System.out.println("adapter for " + adapter.getName() + "requested.");
//		if (adapter == GraphicalViewer.class || adapter == EditPartViewer.class) {
////			return getGraphicalViewer();
//		} else if (adapter == CommandStack.class) {
////			return getCommandStack();
//		} else if (adapter == EditDomain.class) {
////			return getEditDomain();
//		} else if (adapter == ActionRegistry.class) {
////			return getActionRegistry();
////		} else if (adapter == IPropertySheetPage.class) {
////			return getPropertySheetPage();
////		} else if (adapter == IContentOutlinePage.class) {
////			return getOutlineViewer();
//		}
//		return super.getAdapter(adapter);
//	}
}
