package org.jbpm.graph.command;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.commands.Command;
import org.jbpm.graph.model.Node;

public class NodeChangeConstraintCommand extends Command {

	private Rectangle newConstraint;
	private Rectangle oldConstraint;
	private Node node;
	
	public void execute() {
		if (oldConstraint == null) {
			oldConstraint = new Rectangle(node.getConstraint());
		}
		node.setConstraint(newConstraint);
	}
	
	public void undo() {
		node.setConstraint(oldConstraint);
	}

	public void setNewConstraint(Rectangle newConstraint) {
		this.newConstraint = newConstraint;
	}
	
	public void setNode(Node node) {
		this.node = node;
	}
	
}
