package org.jbpm.graph;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.jbpm.graph.model.Connection;
import org.jbpm.graph.model.Graph;
import org.jbpm.graph.model.Node;

public class ContentProvider {
	
	public static final ContentProvider INSTANCE = new ContentProvider();
	
	public Graph newSampleGraph() {
		Graph result = new Graph();
		Node first = newNode(200, 150, 65, 35, "first");
		Node second = newNode(300, 250, 65, 35, "second");
		Node third = newNode(100, 300, 65, 35, "third");
		result.addNode(first);
		result.addNode(second);
		result.addNode(third);
		newConnection(first, second);
		newConnection(first, third);
		newConnection(second, third);
		return result;
	}
	
	private Node newNode(int x, int y, int width, int height, String name) {
		Node result = new Node();
		result.setConstraint(new Rectangle(new Point(x, y), new Dimension(width, height)));
		result.setName(name);
		return result;
	}

	private Connection newConnection(Node source, Node target) {
		Connection result = new Connection();
		result.setSource(source);
		result.setTarget(target);
		return result;
	}

}
