package org.jbpm.graph.model;

import java.util.ArrayList;
import java.util.List;
import java.util.Observable;

import org.eclipse.draw2d.geometry.Rectangle;

public class Node extends Observable {
		
	private Rectangle constraint;
	private String name;
	private List sourceConnections;
	private List targetConnections;
	
	public Rectangle getConstraint() {
		return constraint;
	}
	
	public void setConstraint(Rectangle constraint) {
		this.constraint = constraint;
		setChanged();
		notifyObservers();
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public List getSourceConnections() {
		if (sourceConnections == null) {
			sourceConnections = new ArrayList();
		}
		return sourceConnections;
	}
	
	public List getTargetConnections() {
		if (targetConnections == null) {
			targetConnections = new ArrayList();
		}
		return targetConnections;
	}
	
	public void addSourceConnection(Connection connection) {
		getSourceConnections().add(connection);		
	}
	
	public void addTargetConnection(Connection connection) {
		getTargetConnections().add(connection);
	}
	
	public void removeSourceConnection(Connection connection) {
		getSourceConnections().remove(connection);
	}
	
	public void removeTargetConnection(Connection connection) {
		getTargetConnections().remove(connection);
	}

}
