package org.jbpm.graph.part;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.draw2d.FreeformLayer;
import org.eclipse.draw2d.FreeformLayout;
import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.LineBorder;
import org.eclipse.gef.EditPolicy;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import org.jbpm.graph.model.Graph;
import org.jbpm.graph.policy.GraphXYLayoutEditPolicy;

public class GraphEditPart extends AbstractGraphicalEditPart {
	
	public GraphEditPart(Graph processDefinition) {
		setModel(processDefinition);
	}
	
	protected List getModelChildren() {
		ArrayList result = new ArrayList();
		result.addAll(((Graph)getModel()).getNodes());
		return result;
	}

	protected IFigure createFigure() {
		FreeformLayer layer = new FreeformLayer();
		layer.setLayoutManager(new FreeformLayout());
		layer.setBorder(new LineBorder(1));
		return layer;
	}

	protected void createEditPolicies() {
		installEditPolicy(EditPolicy.LAYOUT_ROLE, new GraphXYLayoutEditPolicy());
	}
	
}
