package org.jbpm.graph.part;

import org.eclipse.gef.EditPart;
import org.eclipse.gef.EditPartFactory;
import org.jbpm.graph.model.Connection;
import org.jbpm.graph.model.Graph;
import org.jbpm.graph.model.Node;

public class GraphicalEditPartFactory implements EditPartFactory {

	public EditPart createEditPart(EditPart context, Object model) {
		if (model instanceof Graph) {
			return new GraphEditPart((Graph)model); 
		} else if (model instanceof Node) {
			return new NodeEditPart((Node)model);
		} else if (model instanceof Connection){
			return new ConnectionEditPart((Connection)model);
		} else {
			return null;
		}
	}			

}
