package org.jbpm.graph;

import org.eclipse.gef.palette.ConnectionCreationToolEntry;
import org.eclipse.gef.palette.CreationToolEntry;
import org.eclipse.gef.palette.PaletteGroup;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.PaletteSeparator;
import org.eclipse.gef.palette.SelectionToolEntry;
import org.jbpm.graph.factory.ConnectionFactory;
import org.jbpm.graph.factory.NodeFactory;

public class GraphPalette extends PaletteRoot {
	
	PaletteGroup group;
	
	public GraphPalette() {
		addGroup();
		addSelectionTool();
		addSeparator();
		addNodeTool();
		addSeparator();
		addConnectionTool();
	}

	private void addGroup() {
		group = new PaletteGroup("Graph Controls");
		add(group);
	}
	
	private void addSelectionTool() {
		SelectionToolEntry entry = new SelectionToolEntry();
		entry.setId("org.jbpm.graph.ui.palette.selection");
		group.add(entry);
		setDefaultEntry(entry);
	}
	
	private void addSeparator() {
		PaletteSeparator separator = new PaletteSeparator();
		separator.setId("org.jbpm.graph.ui.palette.separator");
		group.add(separator);
	}
	
	private void addNodeTool() {
		CreationToolEntry entry = new CreationToolEntry(
				"Node", "Creates a new node.", new NodeFactory(), null, null);
		entry.setId("org.jbpm.graph.ui.palette.node");
		group.add(entry);		
	}
	
	private void addConnectionTool() {
		ConnectionCreationToolEntry entry = new ConnectionCreationToolEntry(
				"Connection", "Creates a new connection.", new ConnectionFactory(), null, null);
		entry.setId("org.jbpm.graph.ui.palette.connection");
		group.add(entry);		
	}

}
