package org.jbpm.graph.command;

import org.eclipse.draw2d.geometry.Dimension;
import org.eclipse.draw2d.geometry.Point;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.commands.Command;
import org.jbpm.graph.model.Graph;
import org.jbpm.graph.model.Node;

public class NodeCreateCommand extends Command {

	private static final Dimension INITIAL_NODE_DIMENSION = new Dimension(65, 35);
	
	private Node node;
	private Rectangle constraint;
	private Graph parent;
	
	public void execute() {
		setNodeConstraint();
		setNodeName();
		parent.addNode(node);
	}
	
	private void setNodeName() {
		node.setName(parent.getNextNodeName());
	}
	
	private void setNodeConstraint() {
		if (constraint != null) {
			node.setConstraint(constraint);
		}		
	}
	
	public void undo() {
		parent.removeNode(node);
	}
	
	public void setNode(Node node) {
		this.node = node;
	}
	
	public void setLocation(Point location) {
		this.constraint = new Rectangle(location, INITIAL_NODE_DIMENSION);
	}
	
	public void setParent(Graph parent) {
		this.parent = parent;
	}
	
	
}
