package org.jbpm.graph.model;

import java.util.ArrayList;
import java.util.List;
import java.util.Observable;

public class Graph extends Observable {
	
	private List<Node> nodes;
	
	public List<Node> getNodes() {
		if (nodes == null) {
			nodes = new ArrayList<Node>();
		}
		return nodes;
	}
	
	public void addNode(Node node) {
		getNodes().add(node);
		setChanged();
		notifyObservers();
	}
	
	public void removeNode(Node node) {
		getNodes().remove(node);
		setChanged();
		notifyObservers();
	}
	
	public String getNextNodeName() {
		int runner = 1;
		while (true) {
			String candidate = "node" + runner;
			if (getNodeByName(candidate) == null) {
				return candidate;
			}
			runner ++;
		}		
	}
	
	private Node getNodeByName(String candidate) {
		for (int i = 0; i < getNodes().size(); i++) {
			if (candidate.equals(((Node)getNodes().get(i)).getName())) {
				return (Node)getNodes().get(i);
			}
		}
		return null;
	}
	
}
