package org.jbpm.graph.part;

import java.util.List;
import java.util.Observable;
import java.util.Observer;

import org.eclipse.draw2d.IFigure;
import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.editparts.AbstractGraphicalEditPart;
import org.jbpm.graph.figure.NodeFigure;
import org.jbpm.graph.model.Connection;
import org.jbpm.graph.model.Node;

public class NodeEditPart extends AbstractGraphicalEditPart implements Observer { 
	
	public NodeEditPart(Node node) {
		setModel(node);
	}

	protected IFigure createFigure() {
		return new NodeFigure();
	}

	public void refreshVisuals() {
		NodeFigure figure = (NodeFigure)getFigure();
		Node node = (Node)getModel();
		GraphEditPart parent = (GraphEditPart)getParent();
		figure.getLabel().setText(node.getName());
		Rectangle r = new Rectangle(node.getConstraint());
		parent.setLayoutConstraint(this, figure, r);
	}
	
	protected void createEditPolicies() {
	}

	protected List<Connection> getModelSourceConnections() {
		return ((Node)getModel()).getSourceConnections();
	}
	
	protected List<Connection> getModelTargetConnections() {
		return ((Node)getModel()).getTargetConnections();
	}

	public void activate() {
		if (!isActive()) {
			((Node)getModel()).addObserver(this);
			super.activate();
		}
	}
	
	public void deactivate() {
		if (isActive()) {
			((Node)getModel()).deleteObserver(this);
			super.deactivate();
		}
	}
				
	public void update(Observable observable, Object message) {
		refreshVisuals();		
	}
	
}
