package org.jbpm.graph.policy;

import org.eclipse.draw2d.geometry.Rectangle;
import org.eclipse.gef.EditPart;
import org.eclipse.gef.Request;
import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.XYLayoutEditPolicy;
import org.eclipse.gef.requests.CreateRequest;
import org.jbpm.graph.command.NodeChangeConstraintCommand;
import org.jbpm.graph.command.NodeCreateCommand;
import org.jbpm.graph.model.Graph;
import org.jbpm.graph.model.Node;

public class GraphXYLayoutEditPolicy extends XYLayoutEditPolicy {

	protected Command createChangeConstraintCommand(EditPart child,
			Object constraint) {
		NodeChangeConstraintCommand changeConstraintCommand = new NodeChangeConstraintCommand();
		changeConstraintCommand.setNode((Node)child.getModel());
		changeConstraintCommand.setNewConstraint((Rectangle)constraint);
		return changeConstraintCommand;
	}
	
	protected Command getCreateCommand(CreateRequest request) {
		if (request.getNewObjectType().equals(Node.class)) {
			return getNodeCreateCommand(request);
		}
		return null;
	}

	private Command getNodeCreateCommand(CreateRequest request) {
		NodeCreateCommand result = new NodeCreateCommand();
		result.setLocation(request.getLocation());
		result.setNode((Node)request.getNewObject());
		result.setParent((Graph)getHost().getModel());
		return result;
	}

	// We use a stub implementation for the other methods

	protected Command createAddCommand(EditPart child, Object constraint) {
		return null;
	}

	protected Command getDeleteDependantCommand(Request request) {
		return null;
	}

}
