package org.jbpm.graph.command;

import org.eclipse.gef.commands.Command;
import org.jbpm.graph.model.Connection;
import org.jbpm.graph.model.Node;

public class ConnectionCreateCommand extends Command {

	private Node source;
	private Node target;
	private Connection connection;
	
	public boolean canExecute() {
		return source != null && target != null;
	}
	
	public void setSource(Node source) {
		this.source = source;
	}
	
	public void setTarget(Node target) {
		this.target = target;
	}
	
	public void setConnection(Connection connection) {
		this.connection = connection;
	}
	
	public void execute() {
		connection.setSource(source);
		connection.setTarget(target);
	}
	
	public void undo() {
		connection.setSource(null);
		connection.setTarget(null);
	}
	
}
