package org.jbpm.graph.policy;

import org.eclipse.gef.commands.Command;
import org.eclipse.gef.editpolicies.GraphicalNodeEditPolicy;
import org.eclipse.gef.requests.CreateConnectionRequest;
import org.eclipse.gef.requests.ReconnectRequest;
import org.jbpm.graph.command.ConnectionCreateCommand;
import org.jbpm.graph.model.Connection;
import org.jbpm.graph.model.Node;

public class NodeGraphicalNodeEditPolicy extends GraphicalNodeEditPolicy {

	protected Command getConnectionCompleteCommand(CreateConnectionRequest request) {
		ConnectionCreateCommand result = (ConnectionCreateCommand)request.getStartCommand();
		result.setTarget((Node)getHost().getModel());
		return result;
	}

	protected Command getConnectionCreateCommand(CreateConnectionRequest request) {
		ConnectionCreateCommand result = new ConnectionCreateCommand();
		result.setSource((Node)getHost().getModel());
		result.setConnection((Connection)request.getNewObject());
		request.setStartCommand(result);
		return result;
	}

	protected Command getReconnectTargetCommand(ReconnectRequest request) {
		return null;
	}

	protected Command getReconnectSourceCommand(ReconnectRequest request) {
		return null;
	}

}
