package org.jbpm.graph.command;

import org.eclipse.gef.commands.Command;
import org.jbpm.graph.model.Connection;
import org.jbpm.graph.model.Node;

public class ConnectionDeleteCommand extends Command {

	private Node source;
	private Node target;
	private Connection connection;
	
	public void setConnection(Connection connection) {
		this.connection = connection;
	}
	
	public void execute() {
		if (source == null) {
			source = connection.getSource();
		}
		if (target == null) {
			target = connection.getTarget();
		}
		connection.setSource(null);
		connection.setTarget(null);
	}
	
	public void undo() {
		connection.setSource(source);
		connection.setTarget(target);
	}
	
}
